package lab4;

public class StringCommandReplace implements StringCommand {
    
    private final int start;
    private final int end;
    private final String newStr;
    private String oldStr;

    public StringCommandReplace(int start, int end, String newStr) {
        this.start = start;
        this.end = end;
        this.newStr = newStr;
    }

    @Override
    public void execute(StringBuilder receiver) {
        this.oldStr = receiver.substring(start,end);
        receiver.replace(start,end,newStr);
    }
    
    @Override
    public void undo(StringBuilder receiver) {
        receiver.replace(start,start+newStr.length(),oldStr);
    }
}
