package lab4;

import java.util.ArrayList;
import java.util.List;

public class StringCommandSequence implements StringCommand {
    
    private final List<StringCommand> commands;

    public StringCommandSequence() {
        this.commands = new ArrayList();
    }
    
    public void addCommand(StringCommand com) {
        commands.add(com);
    }

    @Override
    public void execute(StringBuilder receiver) {
        for(StringCommand com : commands) {
            com.execute(receiver);
        }
    }

    @Override
    public void undo(StringBuilder receiver) {
        for(int i = commands.size()-1; i>=0; i--) {
            commands.get(i).undo(receiver);
        }
    }
    
}
