package lab4;

public class StringManipulator {
    
    private final StringBuilder str;
    private final StringCommand[] commands;
    private int currentCommand;
    private int listEnd;

    public StringManipulator(String str) {
        this.str = new StringBuilder(str);
        commands = new StringCommand[100];
        currentCommand = -1;
        listEnd = -1;
        System.out.println(str);
    }
    
    public void append(String appendix) {
        StringCommand com = new StringCommandAppend(appendix);
        addToList(com);
        System.out.println(str);
    }
    
    public void insert(int offset, String insertion) {
        StringCommand com = new StringCommandInsert(offset,insertion);
        addToList(com);
        System.out.println(str);
    }
    
    public void replace(int start, int end, String newStr) {
        StringCommand com = new StringCommandReplace(start,end,newStr);
        addToList(com);
        System.out.println(str);
    }
    
    public void addMacro(StringCommand macro) {
        addToList(macro);
        System.out.println(str);
    }
    
    public void undo() {
        if (currentCommand >= 0) {
            commands[currentCommand].undo(str);
            currentCommand--;
            System.out.println(str);
        } else {
            System.out.println("Nothing to undo.");
        }
    }
    
    public void redo() {
        if (currentCommand < listEnd) {
            currentCommand++;
            commands[currentCommand].execute(str);
            System.out.println(str);
        } else {
            System.out.println("Nothing to redo.");
        }
        
    }
    
    private void addToList(StringCommand com) {
        if (currentCommand < 99) {
            currentCommand++;
            commands[currentCommand] = com;
            listEnd = currentCommand;
            com.execute(str);
        } else {
            System.out.println("Buffer full, command ignored.");
        }
    }
    
}
